// 002 u_dataset
// 03 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

// generic tTable
//   must NOT contain ainy specific dbf info

(*$r+*)

unit u_dataset;
  interface
    // uses Classes;
    uses Db;

    function f_field_type_name(p_field_type: tFieldtype): String;
    function f_field_type_name_to_field_type(p_field_type_name: String): tFieldType;

    function f_data_set_state(p_state: tDataSetState): String;

  implementation
    uses SysUtils, TypInfo
        , u_c_display;

    function f_field_type_name(p_field_type: tFieldtype): String;
      begin
        Result:= GetEnumName(TypeInfo(tFieldType), Integer(p_field_type));
        // Delete(Result, 1, 2);
        // Delete(Result, Length(Result)- Length('_symbol')+ 1, Length('_symbol'));
      end; // f_parser_symbol_name

    function f_field_type_name_to_field_type(p_field_type_name: String): tFieldType;
(*
      const k_dataset_type_array: array[0..37] of tFieldType=
        (ftUnknown, ftString, ftSmallint, ftInteger, ftWord, ftBoolean, ftFloat, ftCurrency,
        ftBCD, ftDate, ftTime, ftDateTime, ftBytes, ftVarBytes, ftAutoInc, ftBlob, ftMemo,
        ftGraphic, ftFmtMemo, ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor,
        ftFixedChar, ftWideString, ftLargeint, ftADT, ftArray, ftReference, ftDataSet,
        ftOraBlob, ftOraClob, ftVariant, ftInterface, ftIDispatch, ftGuid, ftTimeStamp, ftFMTBcd);
*)
      const k_dataset_type_array: array[ftUnknown..ftFMTBcd] of String=
      //         TStringField
        ('xxx', 'TStringField', 'TSmallintField', 'TIntegerField', 'TWordField', 'TBooleanField', 'TFloatField',
        'TCurrencyField', 'TBCDField', 'TDateField', 'TTimeField', 'TDateTimeField', 'TBytesField', 'TVarBytesField',
        'TAutoIncField', 'TBlobField', 'TMemoField', 'TGraphicField', 'TFmtMemoField', 'TParadoxOleField',
        'TDBaseOleField', 'TTypedBinaryField', 'TCursorField', 'TFixedCharField', 'TWideStringField',
        'TLargeintField', 'TADTField', 'TArrayField', 'TReferenceField', 'TDataSetField', 'TOraBlobField',
        'TOraClobField', 'TVariantField', 'TInterfaceField', 'TIDispatchField', 'TGuidField',
        'TTimeStampField', 'TFMTBcdField');
      begin
        // display('> typ '+ p_field_type_name);
        Result:= ftFMTBcd;
        k_dataset_type_array[ftUnknown]:= p_field_type_name;
        while k_dataset_type_array[Result]<> p_field_type_name do
        begin
          Dec(Result);
          // display(Format('%-15s', [k_dataset_type_array[Result]])+ p_field_type_name);
        end; // while
        // display('<  type= '+ f_field_type_name(Result));
      end; // f_field_type_name_to_field_type

    function f_data_set_state(p_state: tDataSetState): String;
      begin
        case p_state of
          dsInsert: Result:= 'dsInsert';
          dsBrowse: Result:= 'dsBrowse';
          dsEdit: Result:= 'dsEdit';
          else Result:= '?';
        end;
      end; // f_data_set_state

    end.

