// 002 u_reverse_database
// 04 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_reverse_database;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    Memo2: TMemo;
    Panel1: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    all_dir_: TButton;
    exit_: TButton;
    clear_: TButton;
    all_dir_recursive_: TButton;
    scan_: TCheckBox;
    disp_s_: TCheckBox;
    disp_p_: TCheckBox;
    extract_: TButton;
    tree_: TCheckBox;
    display_object_tree_: TButton;
    FilterComboBox1: TFilterComboBox;
    display_list_: TButton;
    extract__: TCheckBox;
    fields_: TCheckBox;
    extract_sql_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure all_dir_Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure all_dir_recursive_Click(Sender: TObject);
    procedure extract_Click(Sender: TObject);
    procedure generate_same_Click(Sender: TObject);
    procedure display_object_tree_Click(Sender: TObject);
    procedure compare_scan_Click(Sender: TObject);
    procedure display_list_Click(Sender: TObject);
    procedure extract_sql_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_types_constants
      , u_c_log, u_c_display
      , u_file, u_dir
      , u_strings, u_stringlist
      , u_handle_files_in_dirs
      , u_c_dfm_scanner
      , u_c_dfm_parser
      , u_c_dfm_object

      , u_c_analyze_db
      , u_c_dataset_list
      ;

   
 
    {$R *.DFM}

    const k_root_directory= '..\_data\';
          k_initial_directory= k_root_directory; // + '_data\IbMastApp\'; // + 'prog_dfm_txt\';

            k_extension= '.pas';
            k_file_name= 'pascal.pas';

    var g_path: String= k_initial_directory;
        g_root_path: String= k_initial_directory;
        g_file_name: String= k_file_name;
        g_file_count: Integer= 0;
        g_ok_file_count: Integer= 0;

        // -- represents the tree of a single dfm
        g_c_dfm_object: c_dfm_object= Nil;
        // -- gathers the objects of several dfm's
        g_c_dfm_object_list: c_dfm_object_list= Nil;

        g_c_dataset_list: c_dataset_list= Nil;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      var l_c_dfm_scanner: c_dfm_scanner;
      begin
        g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;

        Inc(g_file_count);

(*
        if g_file_count> 10
          then Exit;
*)
        display('>'+ p_file_name);
        Inc(g_ok_file_count);

        if g_c_dfm_object_list= Nil
          then g_c_dfm_object_list:= c_dfm_object_list.create_dfm_object_list('object_list');

        // -- free any previous tree
        g_c_dfm_object.Free;

        l_c_dfm_scanner:= c_dfm_scanner.create_dfm_scanner('scan', p_path+ p_file_name);

        if Form1.scan_.Checked
          then begin
              l_c_dfm_scanner.m_display_symbol_read:= Form1.disp_s_.Checked;
              l_c_dfm_scanner.test_dfm_scanner;
              Exit;
            end;

        with c_dfm_parser.create_dfm_parser('parser') do
        begin
          m_c_dfm_scanner_ref:= l_c_dfm_scanner;
          l_c_dfm_scanner.m_display_symbol_read:= Form1.disp_s_.Checked;
          m_trace_parser:= Form1.disp_p_.Checked;

          m_c_dfm_object_list_ref:= g_c_dfm_object_list;

          // push_stop_display(1);
          parse_dfm;
          // pop_stop_display;

          // -- swap before free
          g_c_dfm_object:= m_c_dfm_object;
          m_c_dfm_object:= Nil;
          Free;
        end; // with c_dfm_scanner

        if Form1.extract__.Checked
          then Form1.extract_Click(Nil);

        change_indentation(-2);  
      end; // my_call_back

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_directory_listbox_directory(DirectoryListBox1, k_initial_directory);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        display_path_and_file;
        g_root_path:= g_path;
      end; // DirectoryListBox1Change

    // -- call handler

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      var l_path, l_name: String;
      begin
        l_path:= DirectoryListBox1.Directory;
        with FileListbox1 do
          l_name:= Items[ItemIndex];

        g_file_count:= 0;
        my_call_back(0, l_path+ '\', l_name, Nil);
      end; // FileListBox1Click

    procedure handle_the_files(p_dir_handling_types: t_dir_handling_types);
      var l_extension: String;
          l_path: String;
      begin
        l_path:= f_without_ending_slash(g_path);

        // l_extension:= '*.txt';
        l_extension:= Form1.FileListBox1.Mask;
        Delete(l_extension, 1, 1);
        l_extension:= UpperCase(l_extension);

        display_line;
        display('handle_non_rec of '+ l_path+ ' '+ l_extension);
        display_line;

        g_file_count:= 0;
        g_ok_file_count:= 0;

        handle_all_files_recursive(1, l_path, l_extension,
            p_dir_handling_types, my_call_back, Nil);

        display_line;
        display('FINISHED '+ Format('cnt =%3d / %3d', [g_ok_file_count, g_file_count]));
      end; // handle_the_files

    procedure TForm1.all_dir_Click(Sender: TObject);
      // -- all the file of this folder (non rec)
      begin
        handle_the_files([e_dir_handle_file]);
      end; // btn_all_dirClick

    procedure TForm1.all_dir_recursive_Click(Sender: TObject);
      begin
        handle_the_files([e_dir_handle_file, e_dir_recursive]);
      end; // all_dir_recursive_Click

    procedure TForm1.display_object_tree_Click(Sender: TObject);
      begin
        g_c_dfm_object.display_dfm_object_tree;
      end; // display_object_tree_Click

    procedure TForm1.compare_scan_Click(Sender: TObject);

      procedure generate_from_scanner;
        begin
          with c_dfm_scanner.create_dfm_scanner('scan', g_path+ g_file_name) do
          begin
            scan_and_save(g_path+ 'scan.txt');
          end; // with c_dfm_scanner
        end; // generate_from_scanner

      procedure generate_from_tree;
        begin
          // -- the comparison is performed "on the fly"
          g_c_dfm_object.save_to_txt(g_path+ 'scan.txt', g_path+ 'tree.txt');
        end; // generate_from_tree

      begin // compare_Click
        generate_from_scanner;
        generate_from_tree;
      end; // compare_Click

    procedure TForm1.generate_same_Click(Sender: TObject);
      var l_pas_file_name: String;
      begin
        g_c_dfm_object.generate_indented_text(g_path+ 'indented');
        l_pas_file_name:= g_path+ ChangeFileExt(g_file_name, '.pas');
        copy_file(l_pas_file_name, g_path+ 'indented.pas');
        Memo2.Lines.LoadFromFile(g_path+ 'indented.txt')
      end; // generate_same_Click

    procedure TForm1.extract_Click(Sender: TObject);
      begin
        with c_analyze_db.create_analyze_db('analyze') do
        begin
          if g_c_dataset_list= Nil
            then g_c_dataset_list:= c_dataset_list.create_dataset_list('dataset_list');
          m_c_dataset_list_ref:= g_c_dataset_list;

          analyze(g_c_dfm_object);
          Free;
        end;
      end; // modify_Click

    procedure TForm1.display_list_Click(Sender: TObject);
      begin
        with g_c_dataset_list do
        begin
          m_display_fields:= fields_.Checked;
          display_detailed_dataset_list;
        end;
      end; // display_list_Click

    procedure TForm1.extract_sql_Click(Sender: TObject);
      begin
        with g_c_dataset_list do
          extract_sql(g_path+ 'sql.txt');
      end; // extract_sql_Click

end.


