// 002 u_c_dataset_kinds
// 03 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_dataset_kinds;
  interface
    uses u_c_basic_object
        , u_c_dataset_list
        ;

    type c_dataset_table= Class(c_dataset)
                            // -- DataFields of Master (if any)
                            m_masterfields: String;

                            constructor create_dataset_table(p_name: String;
                                p_c_parent_dataset_list: tObject);
                            procedure display_detailed_dataset; Override;
                            Destructor Destroy; Override;
                          end; // c_dataset_table

         c_dataset_query= Class(c_dataset)
                            // -- m_name: the SQL request

                            constructor create_dataset_query(p_name: String;
                                p_c_parent_dataset_list: tObject);
                            procedure display_detailed_dataset; Override;
                            Destructor Destroy; Override;
                          end; // c_dataset_query

  implementation
    uses SysUtils, u_c_display
        , u_strings, u_stringlist
        , u_dataset
        ;

    // -- c_dataset_table

    constructor c_dataset_table.create_dataset_table(p_name: String;
        p_c_parent_dataset_list: tObject);
      begin
        Inherited create_dataset(p_name, c_dataset_list(p_c_parent_dataset_list));
      end; // c_dataset_table

    procedure c_dataset_table.display_detailed_dataset;
      var l_master: String;
      begin
        display(m_name);
        display('  ='+ f_display_separated_list(m_c_component_name_list, ' '));
        if m_master_datasource<> ''
          then begin
              l_master:= '  ^'+ m_master_datasource;
              if m_c_master_dataset_ref<> Nil
                then l_master:= l_master+ ' -> '+ m_c_master_dataset_ref.m_name
                else l_master:= l_master+ ' -> ? ';
              l_master:= l_master+ '['+ m_masterfields+ ']';
              display(l_master);
            end;

        if m_c_parent_dataset_list.m_display_fields
          then display_detailed_dataset_fields;
      end; // display_detailed_dataset

    Destructor c_dataset_table.Destroy;
      begin
        InHerited;
      end; // Destroy

    // -- c_dataset_query

    constructor c_dataset_query.create_dataset_query(p_name: String;
        p_c_parent_dataset_list: tObject);
      begin
        Inherited create_dataset(p_name, c_dataset_list(p_c_parent_dataset_list));
      end; // c_dataset_query

    procedure c_dataset_query.display_detailed_dataset;
     begin
        // xx display(f_format_and_indent(m_name, g_indentation+ 4, 60));
        display(m_name);
        display('  ='+ f_display_separated_list(m_c_component_name_list, ' '));
        if m_master_datasource<> ''
          then begin
              if m_c_master_dataset_ref<> Nil
                then display('  ^'+ m_master_datasource+ ' -> '+ m_c_master_dataset_ref.m_name)
                else display('  ^'+ m_master_datasource+ ' -> ? ');
            end;

        if m_c_parent_dataset_list.m_display_fields
          then display_detailed_dataset_fields;
      end; // display_detailed_dataset

    Destructor c_dataset_query.Destroy;
      begin
        InHerited;
      end; // Destroy


    begin // u_c_yyy
    end. // u_c_yyy
