// 002 i_pure_dfm_parser
// 05 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)


PROCEDURE pure_parse_dfm;
  
  PROCEDURE parse_object;
    
    PROCEDURE parse_property;
      
      PROCEDURE parse_value;
        
        PROCEDURE parse_collection_item;
          BEGIN
            display_trace('> collection_item');
            check(e_IDENTIFIER_symbol);
            read_symbol;
            parse_property;
            WHILE f_symbol_type= e_IDENTIFIER_symbol DO
              parse_property;
            check(e_END_symbol);
            read_symbol;
            display_trace('< collection_item');
          END; // parse_collection_item
      
        BEGIN // parse_value
          display_trace('> value');
          CASE f_symbol_type OF
            e_INTEGER_symbol : 
                read_symbol;
            e_DOUBLE_symbol : 
                read_symbol;
            e_TRUE_symbol : 
                read_symbol;
            e_FALSE_symbol : 
                read_symbol;
            e_STRING_LITTERAL_symbol : 
                read_symbol;
            e_IDENTIFIER_symbol : 
                BEGIN
                  read_symbol;
                  IF f_symbol_type= e_point_symbol
                    THEN BEGIN
                        read_symbol;
                        check(e_IDENTIFIER_symbol);
                        read_symbol;
                      END; // IF [
                END; // n

            e_opening_bracket_symbol :
                BEGIN
                  read_symbol;

                  IF f_symbol_type IN [e_INTEGER_symbol, e_DOUBLE_symbol, e_TRUE_symbol, e_FALSE_symbol, e_STRING_LITTERAL_symbol,
                      e_IDENTIFIER_symbol, e_opening_bracket_symbol, e_opening_parenthesis_symbol, e_opening_brace_symbol, e_lower_symbol]
                    THEN BEGIN
                        parse_value;
                        WHILE f_symbol_type= e_comma_symbol DO
                        BEGIN
                          read_symbol;
                          parse_value;
                        END; // WHILE {
                      END; // IF [

                  check(e_closing_bracket_symbol);
                  read_symbol;
                END; // n
            e_opening_parenthesis_symbol :
                BEGIN
                  read_symbol;
                  parse_value;

                  WHILE f_symbol_type IN [e_plus_symbol,
                      e_INTEGER_symbol, e_DOUBLE_symbol, e_TRUE_symbol, e_FALSE_symbol, e_STRING_litteral_symbol,
                      e_identifier_symbol,
                      e_opening_bracket_symbol, e_opening_parenthesis_symbol, e_opening_brace_symbol] DO
                  BEGIN
                    if f_symbol_type= e_plus_symbol
                      then read_symbol;
                    parse_value;
                  END; // WHILE {
                  check(e_closing_parenthesis_symbol);
                  read_symbol;
                END; // n
            e_opening_brace_symbol :
                BEGIN
                  read_symbol;
                  parse_value;
                  WHILE f_symbol_type IN [e_INTEGER_symbol, e_DOUBLE_symbol, e_TRUE_symbol, e_FALSE_symbol, e_STRING_LITTERAL_symbol,
                      e_IDENTIFIER_symbol, e_opening_bracket_symbol, e_opening_parenthesis_symbol, e_opening_brace_symbol, e_lower_symbol] DO
                    parse_value;
                  check(e_closing_brace_symbol);
                  read_symbol;
                END; // n
            e_lower_symbol :
                BEGIN
                  read_symbol;
                  parse_collection_item;
                  WHILE f_symbol_type= e_IDENTIFIER_symbol DO
                    parse_collection_item;
                  check(e_greater_symbol);
                  read_symbol;
                END; // n
            ELSE display_error('INTEGER, DOUBLE, TRUE, FALSE, STRING, NAME, [, (, {, <');
          END; // case   
          display_trace('< value');
        END; // parse_value
    
      BEGIN // parse_property
        display_trace('> property');
        check(e_IDENTIFIER_symbol);
        read_symbol;
        IF f_symbol_type= e_point_symbol
          THEN BEGIN
              read_symbol;
              check(e_IDENTIFIER_symbol);
              read_symbol;
            END; // IF [
        check(e_equal_symbol);
        read_symbol;
        parse_value;
        display_trace('< property');
      END; // parse_property
  
    BEGIN // parse_object
      display_trace('> object');
      check(e_OBJECT_symbol);
      read_symbol;
      check(e_IDENTIFIER_symbol);
      read_symbol;
      check(e_colon_symbol);
      read_symbol;
      check(e_IDENTIFIER_symbol);
      read_symbol;
      parse_property;
      WHILE f_symbol_type= e_IDENTIFIER_symbol DO
        parse_property;
      WHILE f_symbol_type= e_OBJECT_symbol DO
        parse_object;
      check(e_END_symbol);
      read_symbol;
      display_trace('< object');
    END; // parse_object

  BEGIN // pure_parse_dfm
    display_trace('> dfm');
    parse_object;
    display_trace('< dfm');
  END; // pure_parse_dfm
