// 002 u_c_dfm_object
// 03 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

// -- todo: add delete

(*$r+*)

unit u_c_dfm_object;
  interface
    uses Classes, u_c_basic_object
        , u_c_dfm_scanner;

    type c_dfm_object_list= Class; // forward
         c_dfm_property= // one "property"
                         Class(c_basic_object)
                           // -- m_name: the property name

                           // -- if "Title.Font.Color"
                           m_c_name_list: tStringList;

                           // -- if object tree, value  "xxx= yyy.zzz" saved as 3 values "yyy" "." "zzz"
                           m_c_value_list: tStringList;
                           m_is_set: Boolean;
                           m_is_list: Boolean;
                           m_is_collection: Boolean;
                           // -- modeled as an object list
                           m_c_dfm_collection_object_list: c_dfm_object_list;

                           m_has_brace: Boolean;

                           m_property_type: t_dfm_symbol_type;

                           Constructor create_dfm_property(p_name: String);

                           function f_display_dfm_property: String;
                           function f_c_self: c_dfm_property;
                           procedure add_name(p_name: String);
                           procedure add_value(p_value: String);
                           procedure add_unique_value(p_value: String);
                           procedure update_property_type(p_property_type: t_dfm_symbol_type);
                           function f_display_value_list: String;
                           function f_display_tree_value_list: String;
                           function f_display_name_list: String;

                           Destructor Destroy; Override;
                         end; // c_dfm_property

         c_dfm_property_list= // "property" list
                              Class(c_basic_object)
                                m_c_dfm_property_list: tStringList;

                                Constructor create_dfm_property_list(p_name: String);

                                function f_dfm_property_count: Integer;
                                function f_c_dfm_property(p_dfm_property_index: Integer): c_dfm_property;
                                function f_index_of(p_dfm_property_name: String): Integer;
                                function f_c_find_by_dfm_property(p_dfm_property_name: String): c_dfm_property;
                                function f_c_find_by_dfm_property_name_list(p_dfm_property_name_list: String): c_dfm_property;
                                procedure add_dfm_property(p_dfm_property_name: String; p_c_dfm_property: c_dfm_property);
                                function f_c_add_dfm_property(p_dfm_property_name: String): c_dfm_property;
                                function f_c_add_unique_dfm_property(p_dfm_property_name: String): c_dfm_property;
                                procedure delete_property(p_dfm_property_index: Integer);
                                procedure display_dfm_property_list;

                                Destructor Destroy; Override;
                              end; // c_dfm_property_list

         c_dfm_object= Class; // Forward

         c_dfm_object_list= // "dfm_object" list
                            Class(c_basic_object)
                              m_c_dfm_object_list: tStringList;
                              m_is_collection: Boolean;

                              Constructor create_dfm_object_list(p_name: String);

                              function f_dfm_object_count: Integer;
                              function f_c_dfm_object(p_dfm_object_index: Integer): c_dfm_object;
                              function f_index_of(p_dfm_object_name: String): Integer;
                              function f_c_find_by_dfm_object(p_dfm_object_name: String): c_dfm_object;
                              function f_c_find_by_dfm_object_name(p_dfm_object_name: String): c_dfm_object;
                              procedure add_dfm_object(p_dfm_object_name: String; p_c_dfm_object: c_dfm_object);
                              function f_c_add_dfm_object(p_dfm_object_name: String): c_dfm_object;
                              function f_c_add_unique_dfm_object(p_dfm_object_name: String): c_dfm_object;
                              procedure display_dfm_object_list;

                              procedure display_dfm_object_and_properties;

                              Destructor Destroy; Override;
                            end; // c_dfm_object_list

         c_dfm_object= // one "dfm_object"
                       Class(c_basic_object)
                         // -- "object Table1: TTable"

                         // -- m_name: the object type name "TTable"
                         // --   (this is used to analyze all the types)

                         // -- the Name : "Table1"
                         m_object_name: String;

                         m_is_collection: Boolean;

                         m_c_dfm_object_list_: c_dfm_object_list;
                         m_c_dfm_property_list: c_dfm_property_list;

                         Constructor create_dfm_object(p_name: String);
                         function f_display_dfm_object: String;
                         function f_c_self: c_dfm_object;
                         procedure display_dfm_object_tree;

                         // -- for comparision with scanned text
                         procedure save_to_txt(p_scanner_full_file_name, p_full_file_name: String);
                         // -- for "true" generation
                         procedure generate_indented_text(p_full_file_name: String);
                         function f_find_property_value(p_property_name: String): String;

                         Destructor Destroy; Override;
                       end; // c_dfm_object


  implementation
    uses SysUtils, u_types_constants, u_characters
        , u_c_display, u_strings, u_stringlist;

    // -- c_dfm_property

    Constructor c_dfm_property.create_dfm_property(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_name_list:= tStringList.Create;
        m_c_value_list:= tStringList.Create;
      end; // create_dfm_property

    function c_dfm_property.f_display_dfm_property: String;
      begin
        Result:= Format('%-10s ', [m_name]);
      end; // f_display_dfm_property

    function c_dfm_property.f_c_self: c_dfm_property;
      begin
        Result:= Self;
      end; // f_c_self

    procedure c_dfm_property.update_property_type(p_property_type: t_dfm_symbol_type);
      begin
        if m_property_type= e_unknown_symbol
          then m_property_type:= p_property_type
          else
            if m_property_type<> p_property_type
              then begin
                  if     (m_property_type= e_integer_symbol)
                        and (p_property_type= e_double_symbol)
                      or
                           (m_property_type= e_double_symbol)
                        and (p_property_type= e_integer_symbol)
                    then m_property_type:= e_double_symbol
                    else // -- this flags an inconsitent property type
                         m_property_type:= e_end_of_parse_symbol;
                end;
      end; // update_property_type

    procedure c_dfm_property.add_name(p_name: String);
      begin
        m_c_name_list.Add(p_name);
      end; // add_name

    procedure c_dfm_property.add_value(p_value: String);
      begin
        m_c_value_list.Add(p_value);
      end; // add_value

    procedure c_dfm_property.add_unique_value(p_value: String);
      begin
(*
        if p_value= 'fsBold'
          then display('*** add bold');
*)
        add_unique_name(m_c_value_list, p_value);
      end; // add_unique_value

    function c_dfm_property.f_display_value_list: String;
      begin
        if m_is_set
          then Result:= '[ '
          else
            if m_is_list
              then Result:= '( '
              else Result:= '';

        Result:= Result+ f_display_separated_list(m_c_value_list, ' ');

        if m_is_set
          then Result:= Result+ ' ]'
          else
            if m_is_list
              then Result:= Result+ ' )';
      end; // f_display_value_list

    function c_dfm_property.f_display_tree_value_list: String;
      begin
        if m_is_set
          then Result:= '[ '
          else
            if m_is_list
              then Result:= '( '
              else
                if m_has_brace
                  then Result:= '{'
                  else Result:= '';

        if f_is_quoted_string_list(m_c_value_list)
          then Result:= Result+ f_display_separated_quoted_list(m_c_value_list, ' ')
          else Result:= Result+ f_display_separated_list(m_c_value_list, ' ');

        if m_is_set
          then Result:= Result+ ' ]'
          else
            if m_is_list
              then Result:= Result+ ' )'
              else
                if m_has_brace
                  then Result:= Result+ '}';
      end; // f_display_tree_value_list

    function c_dfm_property.f_display_name_list: String;
      var l_name_index: Integer;
      begin
        Result:= '';

        with m_c_name_list do
          for l_name_index:= 0 to Count- 1 do
            Result:= Result+ '.'+ Strings[l_name_index];
      end; // f_display_name_list

    Destructor c_dfm_property.Destroy;
      begin
        m_c_name_list.Free;
        m_c_value_list.Free;

        InHerited;
      end; // Destroy

    // -- c_dfm_property_list

    Constructor c_dfm_property_list.create_dfm_property_list(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_dfm_property_list:= tStringList.Create;
      end; // create_dfm_property_line

    function c_dfm_property_list.f_dfm_property_count: Integer;
      begin
        Result:= m_c_dfm_property_list.Count;
      end; // f_dfm_property_count

    function c_dfm_property_list.f_c_dfm_property(p_dfm_property_index: Integer): c_dfm_property;
      begin
        Result:= c_dfm_property(m_c_dfm_property_list.Objects[p_dfm_property_index]);
      end; //  f_c_dfm_property

    function c_dfm_property_list.f_index_of(p_dfm_property_name: String): Integer;
      begin
        Result:= m_c_dfm_property_list.IndexOf(p_dfm_property_name);
      end; // f_index_of

    function c_dfm_property_list.f_c_find_by_dfm_property(p_dfm_property_name: String): c_dfm_property;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_dfm_property_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_dfm_property(m_c_dfm_property_list.Objects[l_index_of]);
      end; // f_c_find_by_dfm_property

    function c_dfm_property_list.f_c_find_by_dfm_property_name_list(p_dfm_property_name_list: String): c_dfm_property;
      var l_index_of: Integer;
      begin
        Result:= Nil;

        For l_index_of:= 0 to f_dfm_property_count- 1 do
          with f_c_dfm_property(l_index_of) do
            if m_name+ f_display_name_list= p_dfm_property_name_list
              then begin
                  Result:= f_c_self;
                  Break;
                end;
      end; // f_c_find_by_dfm_property_name_list

    procedure c_dfm_property_list.add_dfm_property(p_dfm_property_name: String; p_c_dfm_property: c_dfm_property);
      begin
        m_c_dfm_property_list.AddObject(p_dfm_property_name, p_c_dfm_property);
      end; // add_dfm_property

    function c_dfm_property_list.f_c_add_dfm_property(p_dfm_property_name: String): c_dfm_property;
      begin
        Result:= f_c_dfm_property(m_c_dfm_property_list.AddObject(p_dfm_property_name, c_dfm_property.create_dfm_property(p_dfm_property_name)));
      end; // f_c_add_dfm_property

    function c_dfm_property_list.f_c_add_unique_dfm_property(p_dfm_property_name: String): c_dfm_property;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_dfm_property_name);
        if l_index_of>= 0
          then Result:= f_c_dfm_property(l_index_of)
          else Result:= f_c_add_dfm_property(p_dfm_property_name);
      end; // f_c_add_unique_dfm_property

    procedure c_dfm_property_list.delete_property(p_dfm_property_index: Integer);
      begin
        f_c_dfm_property(p_dfm_property_index).Free;
        m_c_dfm_property_list.Delete(p_dfm_property_index); 
      end; // delete_property

    procedure c_dfm_property_list.display_dfm_property_list;
      var l_dfm_property_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_dfm_property_count));

        for l_dfm_property_index:= 0 to f_dfm_property_count- 1 do
          display(f_c_dfm_property(l_dfm_property_index).f_display_dfm_property);
      end; // display_dfm_property_list

    Destructor c_dfm_property_list.Destroy;
      var l_dfm_property_index: Integer;
      begin
        for l_dfm_property_index:= 0 to f_dfm_property_count- 1 do
          f_c_dfm_property(l_dfm_property_index).Free;
        m_c_dfm_property_list.Free;

        Inherited;
      end; // Destroy

    // -- c_dfm_object_list

    Constructor c_dfm_object_list.create_dfm_object_list(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_dfm_object_list:= tStringList.Create;
      end; // create_dfm_object_line

    function c_dfm_object_list.f_dfm_object_count: Integer;
      begin
        Result:= m_c_dfm_object_list.Count;
      end; // f_dfm_object_count

    function c_dfm_object_list.f_c_dfm_object(p_dfm_object_index: Integer): c_dfm_object;
      begin
        Result:= c_dfm_object(m_c_dfm_object_list.Objects[p_dfm_object_index]);
      end; //  f_c_dfm_object

    function c_dfm_object_list.f_index_of(p_dfm_object_name: String): Integer;
      begin
        Result:= m_c_dfm_object_list.IndexOf(p_dfm_object_name);
      end; // f_index_of

    function c_dfm_object_list.f_c_find_by_dfm_object(p_dfm_object_name: String): c_dfm_object;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_dfm_object_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_dfm_object(m_c_dfm_object_list.Objects[l_index_of]);
      end; // f_c_find_by_name

    function c_dfm_object_list.f_c_find_by_dfm_object_name(p_dfm_object_name: String): c_dfm_object;
      var l_index_of: Integer;
      begin
        Result:= Nil;

        for l_index_of:= 0 to f_dfm_object_count- 1 do
          with f_c_dfm_object(l_index_of) do
            if m_object_name= p_dfm_object_name
              then begin
                  Result:= f_c_self;
                  Break;
                end;
      end; // f_c_find_by_dfm_object_name

    procedure c_dfm_object_list.add_dfm_object(p_dfm_object_name: String; p_c_dfm_object: c_dfm_object);
      begin
        m_c_dfm_object_list.AddObject(p_dfm_object_name, p_c_dfm_object);
      end; // add_dfm_object

    function c_dfm_object_list.f_c_add_dfm_object(p_dfm_object_name: String): c_dfm_object;
      begin
        Result:= f_c_dfm_object(m_c_dfm_object_list.AddObject(p_dfm_object_name, c_dfm_object.create_dfm_object(p_dfm_object_name)));
      end; // f_c_add_dfm_object

    function c_dfm_object_list.f_c_add_unique_dfm_object(p_dfm_object_name: String): c_dfm_object;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_dfm_object_name);
        if l_index_of>= 0
          then Result:= f_c_dfm_object(l_index_of)
          else begin
              display('  ok_new_obj '+ p_dfm_object_name);
              Result:= f_c_add_dfm_object(p_dfm_object_name);
            end;
      end; // f_c_add_unique_dfm_object

    procedure c_dfm_object_list.display_dfm_object_list;
      var l_dfm_object_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_dfm_object_count));

        for l_dfm_object_index:= 0 to f_dfm_object_count- 1 do
          display(f_c_dfm_object(l_dfm_object_index).f_display_dfm_object);
      end; // display_dfm_object_list

    procedure c_dfm_object_list.display_dfm_object_and_properties;

      function f_is_ok(p_object_type: String): Boolean;
        begin
          Result:= True;
(*
                   (p_object_type= 'TQuickRep')
            or (Copy(LowerCase(p_object_type), 1, 3)= 'tqr')
*)
        end; // f_is_ok

      var l_dfm_object_index: Integer;
          l_property_index: Integer;
          l_value_list: String;

      begin // display_dfm_object_and_properties
        display(m_name+ ' '+ IntToStr(f_dfm_object_count));

        for l_dfm_object_index:= 0 to f_dfm_object_count- 1 do
          with f_c_dfm_object(l_dfm_object_index) do
            if f_is_ok(m_name)
              then begin
                  display_line;
                  display(m_name);
                  with m_c_dfm_property_list do
                    for l_property_index:= 0 to f_dfm_property_count- 1 do
                      with f_c_dfm_property(l_property_index) do
                      begin
                        display('  '+ m_name+ ' '+ f_dfm_symbol_name(m_property_type));
                        display('    '+ f_format_string(f_display_value_list, 4, 4, 65));
                      end;
                end;
      end; // display_dfm_object_and_properties

    Destructor c_dfm_object_list.Destroy;
      var l_dfm_object_index: Integer;
      begin
        for l_dfm_object_index:= 0 to f_dfm_object_count- 1 do
          f_c_dfm_object(l_dfm_object_index).Free;
        m_c_dfm_object_list.Free;

        Inherited;
      end; // Destroy

    // -- c_dfm_object

    Constructor c_dfm_object.create_dfm_object(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_dfm_object_list_:= c_dfm_object_list.create_dfm_object_list('object_list');
        m_c_dfm_property_list:= c_dfm_property_list.create_dfm_property_list('property_list');
      end; // create_dfm_object

    function c_dfm_object.f_display_dfm_object: String;
      begin
        Result:= Format('%-10s ', [m_name]);
      end; // f_display_dfm_object

    function c_dfm_object.f_c_self: c_dfm_object;
      begin
        Result:= Self;
      end; // f_c_self

    procedure c_dfm_object.display_dfm_object_tree;

      procedure display_recursive(p_level: Integer; p_c_dfm_object: c_dfm_object);
        var l_dfm_object_index: Integer;
            l_property_index: Integer;
        begin
          with p_c_dfm_object do
          begin
            display(f_spaces(2* p_level)+ 'object '+ m_object_name+ ': '+ m_name);

            with m_c_dfm_property_list do
              for l_property_index:= 0 to f_dfm_property_count- 1 do
                with f_c_dfm_property(l_property_index) do
                  display(f_spaces(2* p_level+ 2)+ m_name+ f_display_name_list
                    + '= '+ f_display_tree_value_list);

            with m_c_dfm_object_list_ do
              for l_dfm_object_index:= 0 to f_dfm_object_count- 1 do
                display_recursive(p_level+ 1, f_c_dfm_object(l_dfm_object_index));
                // display('  '+ f_c_dfm_object(l_dfm_object_index).m_name);
            display(f_spaces(2* p_level)+ 'end');
          end; // with p_c_dfm_object
        end; // display_recursive

      begin // display_dfm_object_tree
        display('obj_tree '+ m_name);
        display_recursive(0, Self);
      end; // display_dfm_object_tree

    procedure c_dfm_object.save_to_txt(p_scanner_full_file_name, p_full_file_name: String);
      var l_c_scanner_text, l_c_result_text: tStringList;
          l_scanner_index: Integer;

      procedure add_to_list(p_text: String);
        var l_scanner_name: String;
        begin
          l_c_result_text.Add(p_text);
          if l_scanner_index< l_c_scanner_text.Count
            then begin
                l_scanner_name:= l_c_scanner_text[l_scanner_index];

                if l_scanner_name<> p_text
                  then display_bug_halt('diff '+ l_scanner_name+ '<>'+ p_text);
                Inc(l_scanner_index);
              end;
        end; // add_to_list

      procedure save_recursive(p_level: Integer; p_c_dfm_object: c_dfm_object);

        procedure add_value_list(p_c_dfm_property: c_dfm_property);

          procedure add_collection(p_c_collection: c_dfm_object_list);
            var l_item_index: Integer;
                l_property_index: Integer;
                l_name_index: Integer;
            begin
              with p_c_collection do
                for l_item_index:= 0 to f_dfm_object_count- 1 do
                  with f_c_dfm_object(l_item_index) do
                  begin
                    display(f_spaces(2* p_level+ 2+ 2)+ m_name // + f_display_name_list
                      // + '= '+ f_display_tree_value_list
                      );

                    add_to_list(m_name);
                    with m_c_dfm_property_list do
                      for l_property_index:= 0 to f_dfm_property_count- 1 do
                        with f_c_dfm_property(l_property_index) do
                        begin
                          display(f_spaces(2* p_level+ 2)+ m_name+ f_display_name_list
                            + '= '+ f_display_tree_value_list);
                          add_to_list(m_name);

                          with m_c_name_list do
                            for l_name_index:= 0 to Count- 1 do
                            begin
                              add_to_list('.');
                              add_to_list(m_c_name_list[l_name_index]);
                            end;

                          add_to_list('=');
                          add_value_list(f_c_self);
                        end;
                    add_to_list('end');
                  end;
            end; // add_collection

          var l_list_index: Integer;

          begin // add_value_list
            with p_c_dfm_property do
            begin
              if m_is_set
                then add_to_list('[')
                else
                  if m_is_list
                    then add_to_list('(')
                    else
                      if m_has_brace
                        then add_to_list('{');

              if m_c_dfm_collection_object_list<> Nil
                then begin
                    add_to_list('<');
                    add_collection(m_c_dfm_collection_object_list);
                    add_to_list('>');
                  end
                else
                  with m_c_value_list do
                    for l_list_index:= 0 to Count- 1 do
                    begin
                      add_to_list(Strings[l_list_index]);

                      if m_has_brace
                        then // add_to_list(k_new_line+ f_spaces(2* p_level+ 2))
                        else
                          if m_is_set and (l_list_index< Count- 1)
                            then add_to_list(',');
                    end; // with m_c_value_list, for

              if m_is_set
                then add_to_list(']')
                else
                  if m_is_list
                    then add_to_list(')')
                    else
                      if m_has_brace
                        then add_to_list('}');
            end; // with p_c_dfm_property
          end; // add_value_list

        var l_dfm_object_index: Integer;
            l_property_index: Integer;

        begin // save_recursive
          with p_c_dfm_object do
          begin
            display(f_spaces(2* p_level)+ 'object '+ m_object_name+ ': '+ m_name);
            add_to_list('object');
            add_to_list(m_object_name);
            add_to_list(':');
            add_to_list(m_name);

            with m_c_dfm_property_list do
              for l_property_index:= 0 to f_dfm_property_count- 1 do
                with f_c_dfm_property(l_property_index) do
                begin
                  display(f_spaces(2* p_level+ 2)+ m_name+ f_display_name_list
                    + '= '+ f_display_tree_value_list);

                  add_to_list(m_name);
                  if m_c_name_list.Count> 0
                    then begin
                        add_to_list('.');
                        add_to_list(m_c_name_list[0]);
                      end;
                  add_to_list('=');
                  add_value_list(f_c_self);
                end;

            with m_c_dfm_object_list_ do
              for l_dfm_object_index:= 0 to f_dfm_object_count- 1 do
                save_recursive(p_level+ 1, f_c_dfm_object(l_dfm_object_index));

            display(f_spaces(2* p_level)+ 'end');
            add_to_list('end');
          end; // with p_c_dfm_object
        end; // save_recursive

      begin // save_to_txt
        l_c_result_text:= tStringList.Create;

        l_c_scanner_text:= tStringList.Create;
        l_c_scanner_text.LoadFromFile(p_scanner_full_file_name);
        l_scanner_index:= 0;

        save_recursive(0, Self);

        l_c_scanner_text.Free;
        l_c_result_text.SaveToFile(p_full_file_name);
        l_c_result_text.Free;
      end; // save_to_txt

    procedure c_dfm_object.generate_indented_text(p_full_file_name: String);
      var l_c_result_text: tStringList;

      procedure generate_recursive(p_level: Integer; p_c_dfm_object: c_dfm_object);

        function f_add_tree_value_list(p_c_dfm_property: c_dfm_property): String;

          procedure add_to_list(p_text: String);
            begin
              Result:= Result+ p_text;
            end; // add_to_list

          procedure add_collection(p_c_collection: c_dfm_object_list);
            var l_item_index: Integer;
                l_property_index: Integer;
            begin
              with p_c_collection do
                for l_item_index:= 0 to f_dfm_object_count- 1 do
                  with f_c_dfm_object(l_item_index) do
                  begin
                    add_to_list(f_spaces(2* p_level+ 2+ 2)+ m_name // + f_display_name_list
                      // + '= '+ f_display_tree_value_list
                      + k_new_line
                      );

                    with m_c_dfm_property_list do
                      for l_property_index:= 0 to f_dfm_property_count- 1 do
                        with f_c_dfm_property(l_property_index) do
                        begin
                          //display(f_spaces(2* p_level+ 2)+ m_name+ f_display_name_list
                          //  + '= '+ f_display_tree_value_list);
                          add_to_list(f_spaces(2* p_level+ 2+ 2+ 2)+ m_name+ f_display_name_list);
                          add_to_list(' = ');
                          Result:= Result+ f_add_tree_value_list(f_c_self)+ k_new_line;
                        end;
                    add_to_list(f_spaces(2* p_level+ 2+ 2)+ 'end'+ k_new_line);
                  end;
            end; // add_collection

          var l_list_index: Integer;

          begin // add_value_list
            with p_c_dfm_property do
            begin
              Result:= '';
              if m_is_set
                then add_to_list('[')
                else
                  if m_is_list
                    then add_to_list('(')
                    else
                      if m_has_brace
                        then begin
                            add_to_list('{');
                          end;

              if m_c_dfm_collection_object_list<> Nil
                then begin
                    add_to_list('<'+ k_new_line);
                    add_collection(m_c_dfm_collection_object_list);
                    add_to_list(f_spaces(2* p_level+ 2)+ '>');
                  end
                else
                  with m_c_value_list do
                    for l_list_index:= 0 to Count- 1 do
                    begin
                      add_to_list(Strings[l_list_index]);

                      if m_has_brace
                        then add_to_list(k_new_line+ f_spaces(2* p_level+ 2))
                        else
                          if m_is_set and (l_list_index< Count- 1)
                            then add_to_list(', ');
(*
                      if m_is_set
                        then add_to_list('');
*)
                    end; // with m_c_value_list, for

              if m_is_set
                then add_to_list(']')
                else
                  if m_is_list
                    then add_to_list(')')
                    else
                      if m_has_brace
                        then add_to_list('}');
            end; // with p_c_dfm_property
          end; // f_add_tree_value_list

        var l_dfm_object_index: Integer;
            l_property_index: Integer;

        begin // generate_recursive
          with p_c_dfm_object do
          begin
            l_c_result_text.Add(f_spaces(2* p_level)+ 'object '+ m_object_name+ ': '+ m_name);

            with m_c_dfm_property_list do
              for l_property_index:= 0 to f_dfm_property_count- 1 do
                with f_c_dfm_property(l_property_index) do
                begin
                  l_c_result_text.Add(f_spaces(2* p_level+ 2)+ m_name+ f_display_name_list
                    + ' = '
                    + f_add_tree_value_list(f_c_self));
                end;

            with m_c_dfm_object_list_ do
              for l_dfm_object_index:= 0 to f_dfm_object_count- 1 do
                generate_recursive(p_level+ 1, f_c_dfm_object(l_dfm_object_index));

            l_c_result_text.Add(f_spaces(2* p_level)+ 'end');
          end; // with p_c_dfm_object
        end; // generate_recursive

      begin // generate_indented_text
        l_c_result_text:= tStringList.Create;

        generate_recursive(0, Self);

        l_c_result_text.SaveToFile(p_full_file_name+ '.txt');
        l_c_result_text.SaveToFile(p_full_file_name+ '.dfm');
        l_c_result_text.Free;
      end; // generate_indented_text

    function c_dfm_object.f_find_property_value(p_property_name: String): String;
        // -- search value of "Font.Name"
      var l_c_dfm_property: c_dfm_property;
      begin
        // l_c_dfm_property:= m_c_dfm_property_list.f_c_find_by_dfm_property(p_property_name);
        l_c_dfm_property:= m_c_dfm_property_list.f_c_find_by_dfm_property_name_list(p_property_name);

        if l_c_dfm_property= Nil
          then Result:= ''
          else
            Result:= l_c_dfm_property.f_display_tree_value_list;
      end; // f_find_property_value

    Destructor c_dfm_object.Destroy;
      begin
        m_c_dfm_object_list_.Free;
        m_c_dfm_property_list.Free;

        InHerited;
      end; // Destroy

    begin // u_c_dfm_property_list
    end. // u_c_dfm_object_list
